/*
 * kwin_skulpture.h
 *
 */

#ifndef KWIN_SKULPTURE_H
#define KWIN_SKULPTURE_H 1


/*-----------------------------------------------------------------------*/

#include <kcommondecoration.h>
class QStyleOptionButton;

class SkulptureDecorationButton : public KCommonDecorationButton
{
	Q_OBJECT

	public:
		SkulptureDecorationButton(ButtonType type, KCommonDecoration *parent);
		virtual ~SkulptureDecorationButton();
		virtual void reset(unsigned long changed);

	protected:
		virtual void paintEvent(QPaintEvent *event);

	protected:
		void initStyleOption(QStyleOptionButton &opt);

	private:
		void init();
};


/*-----------------------------------------------------------------------*/

class QStyleOption;

class SkulptureDecoration : public KCommonDecoration
{
	Q_OBJECT

	public:
		SkulptureDecoration(KDecorationBridge *bridge, KDecorationFactory *factory);
		virtual ~SkulptureDecoration();

	public:
		virtual QString visibleName() const;
		virtual bool decorationBehaviour(DecorationBehaviour behaviour) const;
		virtual int layoutMetric(LayoutMetric lm, bool respectWindowState = true, const KCommonDecorationButton *button = 0) const;
		virtual void updateWindowShape();

		virtual void init();
		virtual KCommonDecorationButton *createButton(ButtonType type);

		virtual void paintEvent(QPaintEvent *event);

	protected:
		void initStyleOption(QStyleOption &opt);

	private:
		/* cached style hints and pixel metrics */
		bool coloredFrame;
		bool contrastFrame;
		bool noBorder;
		bool autoRaise;
		int titleHeight;
		int borderWidth;
};


/*-----------------------------------------------------------------------*/

#include <kdecorationfactory.h>

class SkulptureDecorationFactory : public KDecorationFactory
{
	public:
		SkulptureDecorationFactory();
		virtual ~SkulptureDecorationFactory();

	public:
		virtual KDecoration *createDecoration(KDecorationBridge *bridge);
		virtual bool reset(unsigned long changed);
		virtual QList<BorderSize> borderSizes() const;
		virtual bool supports(Ability ability) const;
};


/*-----------------------------------------------------------------------*/

#endif


